// E-flio B - Introduo  Programao 2024/25

#include <stdlib.h>
#include <stdio.h>

// cdigos para as funes das abelhas, ordem do enunciado
#define ABELHA_FAX 0
#define ABELHA_NUT 1
#define ABELHA_CON 2
#define ABELHA_GUA 3
#define ABELHA_FOR 4
#define ABELHA_ZAN 5
#define ABELHA_RAI 6
#define ABELHA_OVO 7
#define ABELHA_LAR 8
#define ABELHA_PUP 9

// cdigos para clulas
#define CELULA_MEL 0
#define CELULA_POL 1
#define CELULA_NEC 2
#define CELULA_CRI 3
#define CELULA_ZAN 4
#define CELULA_REA 5


void DistribuirAbelhas(int funcaoAbelha[10], int nAbelhas) {
	int i;
	// inicializar o nmero de abelhas
	for (i = ABELHA_FAX; i <= ABELHA_PUP; i++)
		funcaoAbelha[i] = 0;

	if (nAbelhas < 200) 
		return;

	// zanges e rainha tm nmero fixo
	funcaoAbelha[ABELHA_ZAN] = 40;
	funcaoAbelha[ABELHA_RAI] = 1;

	// dias so todos iguais, pelo que multiplica-se a distribuio diria por 40
	nAbelhas /= 40; // fica nmero de abelhas operrias por dia
	for (i = 0; nAbelhas > 0; i++, nAbelhas--)
		funcaoAbelha[i % 5] += 40; // uma abelha por cada dia - operrias de 0 a 4
}

void MostrarQuantidade(int valor) {
	if (valor > 0)
		printf(" %3d", valor);
	else
		printf("    ");
}

void RelatorioColmeia(int funcaoAbelha[10], int celulas[6], int nFavos) {
	int i, j;
	printf("\nRelatorio colmeia: ");
	printf("\n fax nut con gua for zan rai ovo lar pup mel pol nec cri zan rea \n");
	for (i = ABELHA_FAX; i <= ABELHA_PUP; i++)
		MostrarQuantidade(funcaoAbelha[i]);
	for (i = 0; i < nFavos; i++) {
		printf("\n\
    Favo %3d:            celulas vazias:         ", i);
		// clulas de criao esto vazias
		for (j = CELULA_CRI; j <= CELULA_REA; j++)
			MostrarQuantidade(celulas[j]);
		printf("\n\
                                 usadas:");
		// clulas de recursos cheias
		for (j = CELULA_MEL; j <= CELULA_NEC; j++)
			MostrarQuantidade(celulas[j]);
	}
}

int DistribuirCelulas(int celulas[6], int nCelulas) {
	int i, nFavos;
	// inicializar a quantidade de clulas
	for (i = 0; i <= CELULA_REA; i++)
		celulas[i] = 0;

	nFavos = 1 + (nCelulas - 1) / 3000;
	nCelulas /= nFavos;

	// zanges tm uma clula 
	celulas[CELULA_ZAN] = 1;

	// distribuir o nmero de clulas de mel a cri
	for (i = 0; nCelulas > 0; i++, nCelulas--)
		celulas[i % 4]++; // mel cdigo 0, cri cdigo 3

	return nFavos;
}

///////////////////////////////////////////////////////////////////////////
// main: 
int main() 
{
	int nAbelhas, nCelulas, minutos, temporadas;
	int funcaoAbelha[10]; // numero de abelhas em cada funo, ordem do enunciado
	int celulas[6]; // quantidade de clulas de cada tipo
	int nFavos;

	//printf("Quantidade de abelhas: ");
	scanf("%d", &nAbelhas);
	//printf("Quantidade de celulas: ");
	scanf("%d", &nCelulas);
	//printf("Minutos por temporada: ");
	scanf("%d", &minutos);
	//printf("Temporadas: ");
	scanf("%d", &temporadas);

	DistribuirAbelhas(funcaoAbelha, nAbelhas);
	nFavos = DistribuirCelulas(celulas, nCelulas);
	RelatorioColmeia(funcaoAbelha, celulas, nFavos);
}
